#ifndef _H_A3D50C83DEE5A168873C4DFC2D349149_ObjectInBox3D__H_
#define _H_A3D50C83DEE5A168873C4DFC2D349149_ObjectInBox3D__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "object_msgs/msg/dds_opensplice/Object_.h"
#include "sensor_msgs/msg/dds_opensplice/RegionOfInterest_.h"
#include "geometry_msgs/msg/dds_opensplice/Point32_.h"


namespace object_analytics_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  ObjectInBox3D_
            {
                ::object_msgs::msg::dds_::Object_ object_;
                ::sensor_msgs::msg::dds_::RegionOfInterest_ roi_;
                ::geometry_msgs::msg::dds_::Point32_ min_;
                ::geometry_msgs::msg::dds_::Point32_ max_;
            };

            typedef DDS_DCPSStruct_var<ObjectInBox3D_> ObjectInBox3D__var;
            typedef DDS_DCPSStruct_out < ObjectInBox3D_> ObjectInBox3D__out;

        }

    }

}

#endif /* _H_A3D50C83DEE5A168873C4DFC2D349149_ObjectInBox3D__H_ */
