// generated from rosidl_generator_cpp/resource/msg__struct.hpp.em
// generated code does not contain a copyright notice

#ifndef OBJECT_ANALYTICS_MSGS__MSG__MOVING_OBJECTS_IN_FRAME__STRUCT_HPP_
#define OBJECT_ANALYTICS_MSGS__MSG__MOVING_OBJECTS_IN_FRAME__STRUCT_HPP_

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32) && defined(ERROR)
  #undef ERROR
#endif

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// include message dependencies
#include "object_analytics_msgs/msg/moving_object.hpp"  // objects
#include "std_msgs/msg/header.hpp"  // header

#ifndef _WIN32
# define DEPRECATED_object_analytics_msgs_msg_MovingObjectsInFrame __attribute__((deprecated))
#else
# define DEPRECATED_object_analytics_msgs_msg_MovingObjectsInFrame __declspec(deprecated)
#endif

namespace object_analytics_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MovingObjectsInFrame_
{
  using Type = MovingObjectsInFrame_<ContainerAllocator>;

  explicit MovingObjectsInFrame_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    (void)_init;
  }

  explicit MovingObjectsInFrame_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _objects_type =
    std::vector<object_analytics_msgs::msg::MovingObject_<ContainerAllocator>, typename ContainerAllocator::template rebind<object_analytics_msgs::msg::MovingObject_<ContainerAllocator>>::other>;
  _objects_type objects;

  // setters for named parameter idiom
  Type * set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return this;
  }
  Type * set__objects(
    const std::vector<object_analytics_msgs::msg::MovingObject_<ContainerAllocator>, typename ContainerAllocator::template rebind<object_analytics_msgs::msg::MovingObject_<ContainerAllocator>>::other> & _arg)
  {
    this->objects = _arg;
    return this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    object_analytics_msgs::msg::MovingObjectsInFrame_<ContainerAllocator> *;
  using ConstRawPtr =
    const object_analytics_msgs::msg::MovingObjectsInFrame_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<object_analytics_msgs::msg::MovingObjectsInFrame_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<object_analytics_msgs::msg::MovingObjectsInFrame_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      object_analytics_msgs::msg::MovingObjectsInFrame_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<object_analytics_msgs::msg::MovingObjectsInFrame_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      object_analytics_msgs::msg::MovingObjectsInFrame_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<object_analytics_msgs::msg::MovingObjectsInFrame_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<object_analytics_msgs::msg::MovingObjectsInFrame_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<object_analytics_msgs::msg::MovingObjectsInFrame_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED_object_analytics_msgs_msg_MovingObjectsInFrame
    std::shared_ptr<object_analytics_msgs::msg::MovingObjectsInFrame_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED_object_analytics_msgs_msg_MovingObjectsInFrame
    std::shared_ptr<object_analytics_msgs::msg::MovingObjectsInFrame_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MovingObjectsInFrame_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->objects != other.objects) {
      return false;
    }
    return true;
  }
  bool operator!=(const MovingObjectsInFrame_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MovingObjectsInFrame_

// alias to use template instance with default allocator
using MovingObjectsInFrame =
  object_analytics_msgs::msg::MovingObjectsInFrame_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace object_analytics_msgs

#endif  // OBJECT_ANALYTICS_MSGS__MSG__MOVING_OBJECTS_IN_FRAME__STRUCT_HPP_
